Foreman - Bug #8366

Upgrade from 1.6.2 to 1.7rc1 fails during AddUniquelndexToParameter db migration with duplicate
key error

11/12/2014 08:57 AM - Ronald van Zantvoort

Status: Closed
Priority: High
Assignee: Dominic Cleal
Category: DB migrations
Target version: 1.7.2
Difficulty: Fixed in Releases:
Triaged: Found in Releases: 1.7.0
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/1927
Description

Upgrading our Foreman instance from 1.6.2 to 1.7rc1 fails during migration of the DB with the following error:

== AddUniquelIndexToParameter: migrating ======================================
—-— add_index (:parameters, [:reference_id, :name], {:unique=>true})

rake aborted!

StandardError: An error has occurred, all later migrations canceled:

Mysqgl2::Error: Duplicate entry '4-lag-members' for key 'index_parameters_on_reference_id_and_name'
CREATE UNIQUE INDEX " index_parameters_on_reference_id_and_name’ ON ‘parameters’ ( reference_id’,
‘name’ ) /usr/share/foreman/vendor/ruby/1.9.1/gems/activerecord-3.2.20/1ib/active_record/connection
_adapters/abstract_mysqgl_adapter.rb:245:in ‘query'
(etc...)

This is caused by 20140805114754_add_unique_index_to_parameter.rb trying to add the mentioned index. However, in my db, |
have:

id name ref_id type
1 lag-members 4 GroupParameter
3 lag-members 4 HostParameter

Which leads to the SQL violation.
So it looks like anyone upgrading who has the same parameter set on both Group and Host might suffer this problem?

Related issues:
Related to Foreman - Bug #6695: Adding two OS parameters with same name doesn... Closed 07/20/2014

Associated revisions

Revision d5f92b39 - 11/13/2014 01:31 PM - Dominic Cleal

fixes #8366 - add parameter type to unique index

Revision 6db98d62 - 01/27/2015 10:49 AM - Dominic Cleal

fixes #8366 - add parameter type to unique index

(cherry picked from commit d5f92b39de44658f2c73ff87139f7152e6e41208)

History

#1 - 11/12/2014 09:34 AM - Dominic Cleal

- Related to Bug #6695: Adding two OS parameters with same name doesn't raise any error when values are different added

#2 - 11/12/2014 09:35 AM - Dominic Cleal

- Target version setto 1.7.2
Looks like the 'type' should be part of the index, thanks for the report!

#3 - 11/12/2014 11:32 AM - Ori Rabin
- Status changed from New to Assigned

- Assignee set to Ori Rabin

#4 - 11/12/2014 12:31 PM - The Foreman Bot

- Status changed from Assigned to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/1927 added
- Pull request deleted ()

#5 - 11/12/2014 12:33 PM - Dominic Cleal

- Assignee changed from Ori Rabin to Dominic Cleal

Sorry Ori, | thought I'd set assignee but it didn't happen. PR's up if you'd like to review it. If you have another solution, we can compare answers!

#6 - 11/13/2014 02:01 PM - Dominic Cleal
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset d5f92b39de44658f2c73ff87139f7152e6e41208.

#7 - 01/06/2015 09:36 AM - Dominic Cleal

- translation missing: en.field_release changed from 21 to 30
